function Fig1
%problem setting up
% nexact_all = 4*[2,4,10:10:130,230,330];
nexact_all = 4*[2,4,10:10:130,230,330,430,530];  %horizon
v_record = zeros(length(nexact_all), 5);
error = zeros(length(nexact_all),3);
for ii = 1:length(nexact_all)
% for i = 10
    %classical bayesian algo:
    nexact = nexact_all(ii);
    mu2 = 1/2; %deterministic reward
    a = nexact/2; b = nexact/2;%prior

    %HJB:
    mu2_hat = mu2; %mu2_hat
    a_hat = a/nexact; b_hat = (a+b)/nexact; 
    fn = nexact;

    w = zeros(nexact+1,nexact+1);
    for j = nexact:-1:1
        q = 0:j-1; q = q';
        s = (0:j-1); 
        p = (a+s)./(a+b+q); 
        temp1 = p.*w(2:end,2:end) + (1-p).* w(2:end,1:end-1) + p;
        temp2 = w(1:end-1,1:end-1) + mu2;
        w = zeros(size(p));
        idx = temp1 >= temp2; w(idx) = temp1(idx);
        idx = ~idx; w(idx) = temp2(idx);
        
        if j == 1
            t = 0;
            muhat = (a_hat + 0 )./(b_hat+0);
            if muhat < mu2_hat
                v = mu2_hat*(1-t); 
            else
                v = muhat*(1-t);
            end
            w_compare = w(1,1);
            error(ii,3) = abs(w_compare/fn - v);
        end
        if j == round(nexact/2)+1
            t = 1/2;
            muhat = (a_hat + 1/4 )./(b_hat+1/2); 
            if muhat < mu2_hat
                v = mu2_hat*(1-t); 
            else
                v = muhat*(1-t);
            end
            w_compare = w(end,(length(s)-1)/2+1);
            error(ii,1) = abs(w_compare/fn - v);
            
            muhat = (a_hat + 1/8 )./(b_hat+1/4); 
            if muhat < mu2_hat
                v = mu2_hat*(1-t); 
            else
                v = muhat*(1-t);
            end
            w_compare = w(round((length(q)-1)/2)+1,round((length(q)-1)/4)+1);
            error(ii,2) = abs(w_compare/fn - v);
        end

    end

end

figure(2); loglog(nexact_all,error,'-*','LineWidth',2);
set(gca,'FontSize',15)
title('The convergence of $v^i(s,q)$ as the horizon $n\to\infty$','Interpreter','latex','FontSize', 20)
xlabel('n','Interpreter','latex','FontSize', 20); 
legend('$\frac{1}{n}w^{\frac{n}{2}+1}(\frac{n}{4},\frac{n}{2}) - v(\frac{1}{2},\frac{1}{4}, \frac{1}{2})$',...
    '$\frac{1}{n}w^{\frac{n}{2}+1}(\frac{n}{8},\frac{n}{4}) - v(\frac{1}{2},\frac{1}{8}, \frac{1}{4})$',...
    '$\frac{1}{n}w^{1}(0,0) - v(0,0,0)$',...
    'Interpreter','latex','FontSize', 20)
name = 'fig1';
print(gcf, '-depsc', name);
1;










