function Fig2_2
%numerical solution to stochastic case is a good approximation to w^i
%problem setting up

nexact_all = [50:200:1000,2000,3000,5000];
error = zeros(length(nexact_all),1);
error_policy = zeros(length(nexact_all),1);
nhat_all = [50,150,500];
eps=10^(-10);

for stoch = 0:1
for jj = 1:3
    nhat = nhat_all(jj);
for ii = 1:length(nexact_all)
    nexact = nexact_all(ii);
    mu2 = 1/3/sqrt(nexact);
    a = nexact; b = nexact-sqrt(nexact);

    if stoch == 1
        fn = sqrt(nexact); mu2_hat = 1/3;a_hat = 1; b_hat = 2; ds = 1/sqrt(nhat);sighat = 1;
    else
        fn = nexact; mu2_hat = 0; a_hat = 0; b_hat = 2; ds = 1/nhat;
    end
    dt = 1/nhat; 
    dq = 1/nhat;
    
    gap = nhat/nexact;
    %Numerical solu of HJB
    T = nhat+1;
    ad = max(nexact-nhat,0)+1;
    v = zeros(T,2*(T+ad)-1); 

    w = zeros(nexact+1,2*(nexact+1)-1); 
    j = nhat-1;
    z = 0;
    for i = nexact:-1:1
        q = (0:i-1); q = q';
        s = (-(i-1):i-1); 
        p = (a+s/2+q/2)./(a+b+q); 
        temp1 = p.*w(2:end,3:end) + (1-p).* w(2:end,1:end-2) + 2*p-1;
        temp2 = w(1:end-1,2:end-1) + mu2;
        w = zeros(size(p));
        idx = temp1 >= temp2; w(idx) = temp1(idx);
        idx = ~idx; w(idx) = temp2(idx);
        
        while( j >= floor((i-1)/dt/nexact+eps) )
            %sde-control
            qhat = (0:j)*dq; qhat = qhat';
            shat = (-j-ad:j+ad)*ds; 

            muhat = (a_hat+shat)./(b_hat+qhat); 
            temp2 = v(1:end-1,2:end-1) + dt*mu2_hat;
            if stoch == 1
                temp1 = v(1:end-1,2:end-1) + dt*( (v(2:end,3:end) - v(2:end,1:end-2))/(2*ds) .* muhat ...
                    + (v(2:end,2:end-1) - v(1:end-1,2:end-1))/dq ...
                    + (v(2:end,3:end) -2*v(2:end,2:end-1) + v(2:end,1:end-2))/(ds^2) .* sighat/2 + muhat  );
            else
                muhat_plus = max(muhat,0);
                muhat_minu = min(muhat,0);
                temp1 = v(1:end-1,2:end-1) + dt*( (v(2:end,3:end) - v(2:end,2:end-1))/ds .* muhat_plus ...
                    + (v(2:end,2:end-1) - v(2:end,1:end-2))/ds .* muhat_minu ...
                    + (v(2:end,2:end-1) - v(1:end-1,2:end-1))/dq + muhat  );
            end
            v = zeros(size(muhat));
            idx_cts = temp1 >= temp2; v(idx_cts) = temp1(idx_cts);
            idx_cts = ~idx_cts; v(idx_cts) = temp2(idx_cts);
            j = j-1;
        end

        vhat = v(1+floor(q*gap+eps),1+(j+ad+1)+floor(s/ds/fn+eps));
        error(ii) = error(ii) + sum(sum(abs(w/fn - vhat)));
        idx_hat = idx_cts(1+floor(q*gap+eps),1+(j+ad+1)+floor(s/ds/fn+eps));
        error_policy(ii) = error_policy(ii) + sum(sum(abs(idx - idx_hat)));
        
        z = z+size(w,1)*size(w,2);
    end
    
    if stoch == 1
        error(ii) = error(ii)/z/sqrt(nexact);
    else
         error(ii) = error(ii)/z;
    end
    error_policy(ii) = error_policy(ii)/z;
end
    
if stoch == 1
    figure(1); subplot(1,2,2); y = loglog(nexact_all,error,'-*','LineWidth',2);hold on;
    legend(y, ['N = ', num2str(nhat),', f(n) = n^{1/2}'],'Interpreter','latex');
    figure(1); subplot(1,2,1); y = loglog(nexact_all,error_policy,'-*','LineWidth',2);hold on;
    legend(y, ['N = ', num2str(nhat),', f(n) = n^{1/2}'],'Interpreter','latex');
end
if stoch == 0
    figure(1); subplot(1,2,2); y = loglog(nexact_all,error,'-*','LineWidth',2);hold on;
    legend(y, ['N = ', num2str(nhat),', f(n) = n'],'Interpreter','latex');
    figure(1); subplot(1,2,1); y = loglog(nexact_all,error_policy,'-*','LineWidth',2);hold on;
    legend(y, ['N = ', num2str(nhat),', f(n) = n'],'Interpreter','latex');
end
end
end

figure(1); sgtitle('print(gcf, '-depsc', name);
subplot(1,2,2); title('$e^{n,N}_w$','Interpreter','latex'); xlabel('n'); set(gca,'FontSize',25)
subplot(1,2,1); title('$e^{n,N}_\pi$','Interpreter','latex'); xlabel('n'); set(gca,'FontSize',25)
name = 'fig2_2';
print(gcf, '-depsc', name);


1;











