function Fig3_2_1
% test regularized HJB
K = 5; fig_idx = 1; 
% K = 10; fig_idx = 2;
% K = 20; fig_idx = 3; 

lam_all = [0,1,2];
nexact = 10^3;  %horizon
N_simu = 10^3; %number of simulations to get the expectation of the regret
sig = 1; %known of variance
muk = zeros(K,1); %unknown of expectation
muk(1) = 0; N_mu = 10; MU = linspace(-1,1,N_mu);
fn = sqrt(nexact); %scaling factor
a = zeros(K,1); b = zeros(K,1); ahat = zeros(K,1); bhat = zeros(K,1); %prior hyperparameters
a(1:end) = 0.01*sqrt(nexact); b(1:end) = 1;%prior
ahat(1:end) = 0.01; bhat(1:end) = 0; 
% a(1:end) = 1/sqrt(nexact); b(1:end) = 1/sqrt(nexact);%prior
% ahat(1:end) = 1; bhat(1:end) = 1; 


for ii = 1:length(lam_all)
    lam = lam_all(ii);
    n = nexact; T = n;
    R_exp = zeros(N_mu,1);
    for j = 1:N_mu
        muk(2:K) = MU(j); 
        mu = muk;
        R = zeros(N_simu,1);
        for simu = 1:N_simu
            s = zeros(K,1); q=zeros(K,1);
            for t = 1:T
                if t <= K && t >= 1 
                    R(simu) = R(simu) + mu(t);
                    r = normrnd(mu(t),sig);
                    s(t) = s(t)+r; q(t) = q(t)+1;
                else
                    %decide pull which arm at time t
                    muhat = (s/fn+ahat)./(q/n+bhat);
                    if lam == 0
                        [~,k] = max(muhat);
                    else 
                        pai = exp(1/lam*muhat);
                        pai = pai./sum(pai);
                        if sum(pai) == 1
                            k = find(mnrnd(1,pai));
                        else
                            [~,k] = max(muhat);
                        end
                    end
                    R(simu) = R(simu)+mu(k);
                    %get reward at t, and update posterior pt
                    r = normrnd(mu(k),sig);
                    s(k) = s(k)+r; q(k) = q(k)+1;
                end
            end
        end
        if mu(1) > mu(2)
            R = mu(1)*T - R;
        else
            R = mu(2)*T - R;
        end
        R_exp(j) = mean(R);
    end
    figure(1);hold on; subplot(1,2,fig_idx); hold on; y = plot(MU, R_exp,'LineWidth',2); legend(y, ['$\lambda = $', num2str(lam)],'Interpreter','latex');
end


figure(1); subplot(1,2,fig_idx); xlabel('$\Delta$','Interpreter','latex','FontSize',20);
sgtitle('The expected regret of the regularized approximated bayesian algorithm$','Interpreter','latex','FontSize', 25)
title('Normal Rewards','Interpreter','latex','FontSize',20)
name = 'fig2_2';

print(gcf, '-depsc', name);

1;



1;