function Fig3_2_2
%numerical solution to stochastic case is a good approximation to w^i
%problem setting up

nexact = 10^3;
nhat = 100;
eps=10^(-10);
lam_all = [0,0.1,0.2];
x = [0.1,-0.2]; fig_idx = 2;
sigw = 1;sighat = 1;
% alpha = 0; sig = 1/nexact; 
% alphahat = 0; sighatinv = 1; 
alpha = sqrt(nexact); sig = 1;
alphahat = 1 ;sighatinv = 0;

fn = sqrt(nexact); 
dt = 1/nhat; 
dq = 1/nhat;
ds = 1/sqrt(nhat);
ad = 0;

K = 2;
N_theta = 11; Theta = linspace(-1/2,1/2,N_theta); 
N_simu = 10^3;

for iii = 2:length(lam_all)
    lam = lam_all(iii);
    T = nhat+1;
    v = zeros(T,2*(T+ad)-1,2*(T+ad)-1); 
    pistar = cell(nhat, 1);
    for j = nhat-1:-1:0
        t = j*dt;
        qhat = (0:j)*dq; 
        s1hat = (-j-ad:j+ad)*ds; s1hat = s1hat';
        s2hat = (-j-ad:j+ad)*ds; 
        
        mu = (alphahat*sighatinv + x(1)*s1hat + x(2)*s2hat);
        mu = repmat(mu,[1,1,length(qhat)]);
        Q1 = repmat(reshape(qhat,[1,1,length(qhat)]),[length(s1hat), length(s2hat),1]);
        mu = mu./(sighatinv+x(1)^2*Q1 + x(2)^2*(t-Q1));
        mu1hat = permute(mu*x(1),[3,1,2]); 
        mu2hat = permute(mu*x(2),[3,1,2]); 
    
        temp1 =  mu1hat.*(v(2:end,3:end,2:end-1) - v(2:end,1:end-2,2:end-1))/(2*ds) ...
            + (v(2:end,2:end-1,2:end-1) - v(1:end-1,2:end-1,2:end-1))/dq ...
            + 1/2*sighat*(v(2:end,3:end,2:end-1) - 2*v(2:end,2:end-1,2:end-1) + v(2:end,1:end-2,2:end-1))/(ds^2) ...
            + mu1hat;
        temp2 =  mu2hat.*(v(1:end-1,2:end-1,3:end) - v(1:end-1,2:end-1,1:end-2))/(2*ds) ...
            + 1/2*sighat*(v(1:end-1,2:end-1,3:end) - 2*v(1:end-1,2:end-1,2:end-1) + v(1:end-1,2:end-1,1:end-2))/(ds^2) ...
            + mu2hat;
        v = v(1:end-1,2:end-1,2:end-1);
        if lam == 0
            vnew = zeros(size(mu1hat)); 
            idx_cts = temp1 >= temp2; vnew(idx_cts) = v(idx_cts) + dt* temp1(idx_cts);
            idx_cts = ~idx_cts; vnew(idx_cts) = v(idx_cts) + dt* temp2(idx_cts);
            v = vnew;
            idx_cts = ~idx_cts; pistar{j+1} = idx_cts;%the probability of pulling arm 1 at time t = (j-1)*dt with (shat,qhat);
        
        else
            temp1 = temp1/lam; temp2 = temp2/lam;
            vnew = v+dt*lam*log(exp(temp1)+exp(temp2));
            pistar{j+1} = exp(temp1)./(exp(temp1)+exp(temp2));
            v = vnew;
        end
    end
    
    
    n = nexact;  R_exp = zeros(N_theta,1);T = n; 
    for ii = 1:N_theta
        theta = Theta(ii); R = zeros(N_simu,1);
         
        for simu = 1:N_simu
            s = [0,0]; q = [0,0];
            for i = 1:T
                %decide which arm to pull at round t
                if i<=K
                    %initially pull each arms once
                    slt_arm = i;
                else
                    %pull the arms according to the numerical optimal
                    %policy according to the HJB equation
                    idx_t = floor((i-1)/n/dt+eps) + 1;
                    idx_s1 = floor(s(1)/ds/fn+eps)+(idx_t+ad)+1;
                    idx_s2 = floor(s(2)/ds/fn+eps)+(idx_t+ad)+1;
                    idx_q1 = floor(q(1)/dq/nexact+eps)+1;
                    
                    if or(idx_s1 <= 0,idx_s2 >= size(pistar{idx_t},3))
                        slt_arm = 2;
                    else 
                        if or(idx_s1 >= size(pistar{idx_t},2),idx_s2 <= 0)
                            slt_arm = 1;
                        else
                            pinow = pistar{idx_t}(idx_q1,idx_s1,idx_s2);
                            if rand(1) < pinow
                                slt_arm = 1;
                            else
                                slt_arm = 2;
                            end
                        end
                    end
                end
                %pull the selected arm at time t
                xt = x(slt_arm); yt = theta*xt+normrnd(0,sqrt(sigw)); 
                %update regret and (s,q) 
                R(simu) = R(simu)+theta*xt;
                s(slt_arm) = s(slt_arm) + yt;
                q(slt_arm) = q(slt_arm)+1;
            end
        end
        if theta*x(1) < theta*x(2)
            R = theta*x(2) * T - R;
        else
            R = theta*x(1) * T - R;
        end
        R_exp(ii) = mean(R);
    end
    Rhjb_exp = R_exp;
    figure(1); hold on; subplot(1,2,fig_idx); hold on; y = plot(Theta(1:ii), Rhjb_exp(1:ii),'LineWidth',2); legend(y, ['\lambda = ', num2str(lam)],'Interpreter','latex');
end
subplot(1,2,fig_idx); title('Linear Bandits','Interpreter','latex');
xlabel('$\nu$','Interpreter','latex')
1;











