function Fig3_3
%Linear bandits with two arms: y = <theta,x>+w, w\sim N(0,sigw); x \in {x(1), x(2)}; theta \in Theta;
%using baysian: theta_t \sim N(mut, sigt)
n = 10^3;
N_theta = 11; Theta = linspace(-1/2,1/2,N_theta); 
K = 2;
mu0 = 0; sigw = 1; 
sig0 = 1/n; 
N_simu = 10^3;
nexact = n;
x_all = [0.1,-0.1;0.1,-0.2;0.1,0.2];

for ii = 1:3
    fig_idx = ii;
    x = x_all(ii,:);



if (1)%thomson sampling
n = nexact; R_exp = zeros(N_theta,1);R_var = zeros(N_theta,1);T = n;
for i = 1:N_theta
    theta = Theta(i);
    R = zeros(N_simu,1);
    for simu = 1:N_simu
        mut = mu0; sigt = sig0;
        for t = 1:T
            if t<=K
                slt_arm = t;
            else
                %decide pull arm 1 or arm 2 at t
                thetat = normrnd(mut,sqrt(sigt)); [~,slt_arm] = max([thetat*x(1),thetat*x(2)]); 
            end
            %pull the selected arm at time t
            xt = x(slt_arm); yt = theta*xt+normrnd(0,sqrt(sigw)); 
            %update regret and posterior pt
            R(simu) = R(simu)+theta*xt;
            mut = (sigt^(-1)+xt*xt'*sigw^(-1))^(-1)*(sigt^(-1)*mut+xt*yt*sigw^(-1));
            sigt = (sigt^(-1)+xt*xt'*sigw^(-1))^(-1);
        end
    end
    if theta*x(1) < theta*x(2)
        R = theta*x(2) * T - R;
    else
        R = theta*x(1) * T - R;
    end
    R_exp(i) = mean(R);
    R_var(i) = mean(R);
end
RTS_exp = R_exp;
RTS_var = R_var;
figure(1); hold on; subplot(1,3,fig_idx); y = plot(Theta(1:i), RTS_exp(1:i),'LineWidth',2); legend(y, 'Thomson Sampling');
end
1;

if(1)%ucb
lam = 0.1; 
R_exp = zeros(N_theta,1);R_var = zeros(N_theta,1);T = n;
for i = 1:N_theta
    theta = Theta(i);
    R = zeros(N_simu,1);
    for simu = 1:N_simu 
        Vt = lam; Wt = 0; thetahat =0;
        for t = 1:T
            if t<=K
                slt_arm = t;
            else
                %decide pull arm 1 or arm 2 at t
                betat = sqrt(lam) + sqrt(2*log(n^2) + log(1+(t-1)/lam));
                [~,slt_arm] = max(x*thetahat+betat*sqrt(x.^2/Vt));
            end
            %get reward at time t, 
            xt = x(slt_arm);yt = theta*xt+normrnd(0,sqrt(sigw)); 
            %and update theta_hat and regret
            R(simu) = R(simu)+theta*xt;
            Vt = Vt + xt^2; Wt = Wt+xt*yt;
            thetahat = Wt/Vt;
        end
    end
    if theta*x(1) < theta*x(2)
        R = theta*x(2) * T - R;
    else
        R = theta*x(1) * T - R;
    end
    R_exp(i) = mean(R);
    R_var(i) = var(R);
end
Rucb_exp = R_exp;
Rucb_var = R_var;
figure(1); hold on; subplot(1,3,fig_idx); y = plot(Theta(1:i), Rucb_exp(1:i),'LineWidth',2); legend(y, 'UCB');
end

if(1)
fn = sqrt(n);
eps = 10^(-5);
muhat = 0;
sighatinv = 1;
% sighatinv = 0;
if (1) %numerically solve HJB
    
    %numerical setting up
    nhat = 100;
    s_max = 100;
    dt = 1/nhat; 
    sig1 =sigw;
    sig2 =sigw;
    ds1 = sqrt(sig1*dt); 
    ds2 = sqrt(sig2*dt);
    dq = 1/nhat;
    
    %Numerical solu of HJB
    T = nhat; ad = 0;
    sstar = cell(T,1); %At time t*dt, with q = q*dq, s1 = s(k), then if s2>= sstar(k,q,t), one should pull arm2, if s2<sstar(k,q,t), one should pull arm1
    vtp1 = zeros(2*T+2*ad+1,2*T+2*ad+1,T+1); %(s1,s2\in[-q,q]*sqrt(n); q\in[0,T-1])
    test = zeros(T,3);
    for t = T:-1:1
        tn = (t-1)*dt;
        s1 = (-(t+ad-1):(t+ad-1))*ds1; s1 = s1'; 
        s2 = (-(t+ad-1):(t+ad-1))*ds2; 
        q1 = (0:t-1)*dq;
        mu = (muhat*sighatinv + x(1)*s1 + x(2)*s2);
        mu = repmat(mu,[1,1,length(q1)]);
        Q1 = repmat(reshape(q1,[1,1,length(q1)]),[length(s1), length(s2),1]);
        mu = mu./(sighatinv+x(1)^2*Q1 + x(2)^2*(tn-Q1));
        mu1 = mu*x(1); 
        mu2 = mu*x(2); 
        
        
        temp1 = vtp1(2:end-1,2:end-1,1:end-1) ...
            + dt*( mu1.*(vtp1(3:end,2:end-1,2:end) - vtp1(1:end-2,2:end-1,2:end))/ds1/2 ...
            + (vtp1(2:end-1,2:end-1,2:end) - vtp1(2:end-1,2:end-1,1:end-1))/dq ...
            + 1/2*sig1*(vtp1(3:end,2:end-1,2:end) - 2*vtp1(2:end-1,2:end-1,2:end) + vtp1(1:end-2,2:end-1,2:end))/ds1^2 ...
            + mu1 );
        temp2 = vtp1(2:end-1,2:end-1,1:end-1) ...
            + dt*( mu2.*(vtp1(2:end-1,3:end,1:end-1) - vtp1(2:end-1,1:end-2,1:end-1))/ds2/2 ...
            + 1/2*sig2*(vtp1(2:end-1,3:end,1:end-1) - 2*vtp1(2:end-1,2:end-1,1:end-1) + vtp1(2:end-1,1:end-2,1:end-1))/ds2^2 ...
            + mu2 );
        vtp1 = zeros(length(s1),length(s2),length(q1));
        idx = temp1 > temp2; vtp1(idx) = temp1(idx); %arm1
        test(t,1) = sum(sum(sum(idx)));
        idx_equal = temp1 == temp2; test(t,2) = sum(sum(sum(idx_equal)));
        idx = ~idx; vtp1(idx) = temp2(idx); %arm2
        idx_s2big = temp1<temp2;
        test(t,3) = sum(sum(sum(idx_s2big)));
        if (1) 
            temp = zeros(length(s1),length(q1)); s2 = repmat(s2,[length(s1),1]);
            for q1 = 0:t-1
                temp1 = idx(:,:,q1+1);
                temp1 = cumsum(temp1,2) == 1;
                temp3 = sum(temp1,2) == 1;
%                 test_s2 = idx_equal(:,:,q1+1) == temp1;
                temp(temp3,q1+1) = s2(temp1);
                temp(~temp3,q1+1) = s_max;
            end
            sstar{t} = temp;
        end
       
    end 
    sstar_hjb = sstar;
end


if(1) %numerical HJB
    sstar = sstar_hjb;
    n = nexact;  R_exp = zeros(N_theta,1);R_var = zeros(N_theta,1);T = n;  %we coarser mesh in sstar 1/sqrt(napprox) > 1/sqrt(n)
    for i = 1:N_theta
        theta = Theta(i); R = zeros(N_simu,1);
         
        for simu = 1:N_simu
%             idx_t = 1;
            s = [0,0]; q = [0,0];
            for t = 1:T
                %decide which arm to pull at round t
                if t<=K
                    %initially pull each arms once
                    slt_arm = t;
                else
                    %pull the arms according to the numerical optimal
                    %policy according to the HJB equation
                    idx_t = floor((t-1)/n/dt+eps) + 1;
                    idx_s1 = floor(s(1)/ds1/fn+eps)+(idx_t+ad-1)+1;
                    idx_q1 = floor(q(1)/dq/nexact+eps)+1;
                    if idx_s1 <= 0
                        slt_arm = 2;
                    end
                    if idx_s1 > size(sstar{idx_t},1)
                        slt_arm = 1;  
                    end
                    if idx_s1 >=1 && idx_s1 <= size(sstar{idx_t},1)
                        s2star = sstar{idx_t}(idx_s1,idx_q1);
%                         if s(2)/fn > s2star+ds2 %decide which arm to pull
%                             slt_arm = 2;
%                         end
%                         if s2star <= s(2)/fn <= s2star+ds2  %decide which arm to pull
%                             if rand(1) > (s(2)/fn - s2star)/ds2
%                                 slt_arm = 2;
%                             else
%                                 slt_arm = 1;
%                             end
%                         end
%                         if s(2)/fn < s2star %decide which arm to pull
%                             slt_arm = 1;
%                         end
                        if s(2)/fn >= s2star
                            slt_arm = 2;
                        else
                            slt_arm = 1;
                        end
                    end
                end
                %pull the selected arm at time t
                xt = x(slt_arm); yt = theta*xt+normrnd(0,sqrt(sigw)); 
                %update regret and (s,q) 
                R(simu) = R(simu)+theta*xt;
                s(slt_arm) = s(slt_arm) + yt;
                q(slt_arm) = q(slt_arm)+1;
            end
        end
        if theta*x(1) < theta*x(2)
            R = theta*x(2) * T - R;
        else
            R = theta*x(1) * T - R;
        end
        R_exp(i) = mean(R);
        R_var(i) = var(R);
    end
    Rhjb_exp = R_exp;
    Rhjb_var = R_var;
    figure(1); hold on; subplot(1,3,fig_idx); y = plot(Theta(1:i), Rhjb_exp(1:i),'LineWidth',2); legend(y, 'approximated bayesian optimal');
end
end

figure(1);subplot(1,3,fig_idx); xlabel('$\nu$','Interpreter','latex'); 
end

subplot(1,3,1); title('a_1 = 0.1, a_2 = -0.1'); set(gca,'FontSize',20)
subplot(1,3,2); title('a_1 = 0.1, a_2 = -0.2'); set(gca,'FontSize',20)
subplot(1,3,3); title('a_1 = 0.1, a_2 = 0.2'); set(gca,'FontSize',20)
figure(1); sgtitle('The expected regret of the approximated bayesian algorithm, Thomson Sampling, UCB','FontSize', 25)
name = 'fig3_3';

print(gcf, '-depsc', name);

1;



